open Cycles ;;

let g1 : graphe =
  [|
    (* 0 *) [1 ] ;
    (* 1 *) [0 ; 2 ; 4] ;
    (* 2 *) [1 ; 3 ; 4] ;
    (* 3 *) [2 ; 4] ;
    (* 4 *) [2 ; 3 ; 1] ;
  |];;

let g2 : graphe =
  [|
    (* 0 *) [1 ] ;
    (* 1 *) [0 ; 2 ] ;
    (* 2 *) [1] ;
  |];;

let g3 : graphe =
  [|
    (* 0 *) [1 ; 2] ;
    (* 1 *) [0 ; 3] ;
    (* 2 *) [0 ; 3] ;
    (* 3 *) [1 ; 2 ; 4 ; 5 ; 6 ; 7] ;
    (* 4 *) [3 ; 5] ;
    (* 5 *) [3 ; 4 ; 6 ; 7] ;
    (* 6 *) [3 ; 5 ; 7 ; 8] ;
    (* 7 *) [3 ; 5 ; 6 ; 8] ;
    (* 8 *) [6 ; 7]
  |];;

let g4 : graphe =
  [|
    (* 0 *) [1 ; 2 ; 3 ; 4] ;
    (* 1 *) [0 ; 2] ;
    (* 2 *) [0 ; 1 ; 3 ; 4] ;
    (* 3 *) [0 ; 2 ; 3 ; 5] ;
    (* 4 *) [0 ; 2 ; 3 ; 5] ;
    (* 5 *) [3 ; 4]
  |];;

let s_cycle ( c : cycle ) : string =
  String.concat "--" ( List.map string_of_int c ) ;;

Printf.printf "Question 1 : \n|- %s\n"
  ( String.concat "\n|- "
      ( List.map
          ( fun g -> s_cycle ( recherche_cycle g ) )
          [g1 ; g2 ; g3 ; g4 ] ) ) ;;

Printf.printf "Question 2 : \n" ;;
List.iter
  (fun (g,c) -> Printf.printf "%s : %s\n"
                  ( s_cycle c )
                  ( if est_eulerien g c then "Oui" else "Non") )
[ (g1, [1;2;3;4;1]) ; (* Non *)
  (g3, [1;0;2;3;4;5;7;8;6;5;3;7;6;3;1]) ; (* Oui *)
  (g3, [6;5;4;3;6;5;4;3;5;7;6;5;7;8;6]) ; (* Non *)
  (g3, [6;5;7;3;6;5;4;3;5;7;6]) ; (* Non *)
  (g4, [0;1;2;3;5;4;0]) ; (* Non *)
  (g4, [0;1;2;0;4;3;2;4;5;3;0]) ; (* Oui *)
];;

Printf.printf "Question 4 : \n|- %s\n"
  ( String.concat "\n|- "
      ( List.map
          ( fun g -> s_cycle ( cycle_eulerien g ) )
          [g1 ; g2 ; g3 ; g4 ] ) ) ;;

Printf.printf "Question 5 : \n|- %s\n"
  ( String.concat "\n|- "
      ( List.map
          ( fun g -> s_cycle ( cycle_hamiltonien g ) )
          [g1 ; g2 ; g3 ; g4 ] ) ) ;;
